//now we don't need the MySQL library

//PFont font1 = createFont("UniversLTStd-Obl", 16); //"Helvetica" the documentary <-- netflix 
int border = 20;
int row = 11;
int col = 8;
//int[] row = new int[10];
//int[] column = new int[8];
float[][] data = new float[row][col];
boolean showDewey = true;


void setup() {
  size(1080, 720); //size of the sketch window
  colorMode(HSB, 360,100,100,100); //color mode- like RGB or HSB (learn to use HSB because it's the best: http://en.wikipedia.org/wiki/HSL_and_HSV)   
  background(0,0,100,100);
  smooth();
  //noLoop();


  String savedData[] = loadStrings("savedData.txt");
  println("QUERY: " + savedData[0]);
  //savedData.length is going to be 11 since there's only the query and then 10 ROW of data.  
  //temp.length is going to be 8 because there's 8 COLUMNS of data.  the first for loop is going row by row, the second is going column by column. 
 
  for (int i=1; i < savedData.length; i++) {

    String temp[] = split(savedData[i], "^^");

//    println("column 1: " + temp[0]);
//    println("column 2: " + temp[1]);
//    println("column 3: " + temp[2]);
//    println("column 4: " + temp[3]);
//    println("column 5: " + temp[4]);
    
    for (int j=1; j <temp.length; j++){
      data[i-1][j] = Float.parseFloat(temp[j]);
    }
  }   
    //println("column 4 loaded into your array: " + column[3]);
  for (int i = 0; i < row; ++i) {
    for (int j = 1; j < col; ++j) {
      //println(data[i][j]);
      //print(" ");
    }
    //println("");
  }

println(data[row-1][col-1]);
}


void draw() {
    float[] rad = new float[7];
    //stroke(255,50);
    background(0,0,100);
    noStroke();
    PFont font;
    font =  createFont("Arial",44,true);
    textFont(font); 
    fill (0,0,50);
    text("color names in book titles", width/2, 200);
    
    for(int i = 0;i < rad.length; ++i){
        rad[i] = (data[row-1][i+1]/data[row-1][5]);
        //println (data[row-1][0]);
        //println(rad[i]);

        fill( i*360/7,60,90,80);
        circle(width/(rad.length+1) * (i+1), height/2, rad[i]*100);
        fill( i*360/7,60,100,30);
        circle(width/(rad.length+1) * (i+1), height/2, 100);
             if(showDewey == true){
             //for (int j = 0; j < 100; j ++ ) {
             textAlongCurve(width/(rad.length+1) * (i+1), height/2, i);
             //}
             //println("test");
            }
  }
   if(showDewey == true){
     fill (0,0,0);
     text("red", width/(rad.length+1) * (1), height/2+80);
     text("orange", width/(rad.length+1) * (2), height/2+80);
     text("yellow", width/(rad.length+1) * (3), height/2+80);
     text("green", width/(rad.length+1) * (4), height/2+80);
     text("blue", width/(rad.length+1) * (5), height/2+80);
     text("indigo", width/(rad.length+1) * (6), height/2+80);
     text("violet", width/(rad.length+1) * (7), height/2+80);
   }
}


void circle(float xpos, float ypos, float rad){
          ellipseMode(CENTER);
          ellipse(xpos, ypos, rad, rad); 
}


void textAlongCurve(float xpos, float ypos, int colorIndex) {
  String [] message = new String[10];
  message[0] = "000   ";
  
  for (int messageNum = 1; messageNum < 10; messageNum++)
  {
    message[messageNum] = str (messageNum*100) + "   ";
    //println(message[messageNum]);
  }
    
  PFont f;
  f = createFont("Arial",10,true);
  textFont(f);
  // The text must be centered!
  textAlign(CENTER);
  // The radius of a circle
  float textRadius = 52;
  
  pushMatrix();
    translate(xpos, ypos);

  
    // We must keep track of our position along the curve (offset from original position)
    float arclength = 3;
    float sumDewey = data[0][colorIndex+1] + data[1][colorIndex+1] + data[2][colorIndex+1] + data[3][colorIndex+1] + data[4][colorIndex+1] + data[5][colorIndex+1] + data[6][colorIndex+1] + data[7][colorIndex+1] + data[8][colorIndex+1] + data[9][colorIndex+1];
    // For every box
    //println(sumDewey);
    for (int jChar = 0; jChar < 10; jChar ++ ) {
      //fill(0, 0, 100 - ((data[jChar][colorIndex+1])/0.723));
      
      fill(0, 0, 0,((data[jChar][colorIndex+1]) / sumDewey*1000));
      for (int iChar = 0; iChar < message[jChar].length(); iChar ++ ) {
      
        // The character and its width
        char currentChar = message[jChar].charAt(iChar);
        // Instead of a constant width, we check the width of each character.
        float w = textWidth(currentChar); 
        // Each box is centered so we move half the width
        arclength += w/2;
      
        // Angle in radians is the arclength divided by the radius
        // Starting on the left side of the circle by adding PI
        float theta = PI + arclength / textRadius*1.21;
      
        pushMatrix();
      
          // Polar to Cartesian conversion allows us to find the point along the curve. See Chapter 13 for a review of this concept.
          translate(textRadius*cos(theta), textRadius*sin(theta)); 
          // Rotate the box (rotation is offset by 90 degrees)
          rotate(theta + PI/2); 
          text(currentChar,0,0);
          
        popMatrix();
        // Move halfway again
        arclength += w/2;
      }
    }
  popMatrix();
}


void keyPressed(){
 //press spacebar to toggle the grid on and off  
 if(key == ' '){
  showDewey = !showDewey;
  println(showDewey);
  }
}
